package com.ruoyi.project.hit.controller;

import com.alibaba.fastjson.JSONArray;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.hit.domain.PupuUpsHistory;
import com.ruoyi.project.hit.domain.vo.UpsHistoryVO;
import com.ruoyi.project.hit.service.PupuUpsHistoryService;
import com.ruoyi.project.hit.util.Util1;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping("/hit/history")
public class PupuUpsHistoryController extends BaseController {
    @Autowired
    private PupuUpsHistoryService pupuUpsHistoryService;
    @Autowired
    private RedisTemplate redisTemplate;

    /**
     * 历史记录新增
     * @return
     */
    @PutMapping("/add")
    public AjaxResult add()  throws IOException {
        String data = Util1.getdetail();
        ObjectMapper mapper = new ObjectMapper();
        Map<String, Object> map=new HashMap<>();
        try {
            map = mapper.readValue(data, Map.class);
            System.out.println(map);
        } catch (IOException e) {
            e.printStackTrace();
        }
        ArrayList<Map<String,Object>> list = (ArrayList<Map<String,Object>>) map.get("data");

        ArrayList<PupuUpsHistory> newList=new ArrayList<>();

        for (Map<String, Object> stringObjectMap : list) {
            if(stringObjectMap.size()==6){
                PupuUpsHistory historyFromMap = Util1.getHistoryFromMap(stringObjectMap);
                newList.add(historyFromMap);
                String jsonTime= JSONArray.toJSONString(historyFromMap.getTime());
                redisTemplate.opsForValue().set("ups:"+historyFromMap.getUpsId(),jsonTime,5, TimeUnit.MILLISECONDS);
            }
        }
        boolean b = pupuUpsHistoryService.saveBatch(newList);
        return AjaxResult.success(b);
    }

    /**
     * 查看设备历史记录
     * @param upsHistoryVO（upsId,startTime,endTime,pageNum,pageSize）
     * @return
     */
    @GetMapping("/select")
    public TableDataInfo select(@RequestBody UpsHistoryVO upsHistoryVO){
        startPage();
        List<HashMap> select = pupuUpsHistoryService.select(upsHistoryVO);
        return getDataTable(select);
    }


}
