package com.ruoyi.project.hit.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.CustomException;
import com.ruoyi.project.hit.domain.PupuStore;
import com.ruoyi.project.hit.domain.PupuUser;
import com.ruoyi.project.hit.domain.vo.UserLoginVO;
import com.ruoyi.project.hit.service.PupuUserService;
import com.ruoyi.project.hit.mapper.PupuUserMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;



/**
* @author HP
* @description 针对表【pupu_user】的数据库操作Service实现
* @createDate 2024-09-04 11:26:14
*/
@Service
public class PupuUserServiceImpl extends ServiceImpl<PupuUserMapper, PupuUser>
    implements PupuUserService{

    @Resource
    private PupuUserMapper pupuUserMapper;

    @Override
    public PupuUser login(UserLoginVO userLoginVO) {
        LambdaQueryWrapper<PupuUser> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PupuUser::getUserName,userLoginVO.getUserName());
        wrapper.eq(PupuUser::getPassword,userLoginVO.getPassword());
        return pupuUserMapper.selectOne(wrapper);
    }

    @Override
    public int register(PupuUser pupuUser) {
        int i=0;
        try {
            i = pupuUserMapper.insert(pupuUser);
        } catch (Exception e){
            throw new CustomException("账号已存在");
        }
        return i;
    }


}




